// Gets the current display dimensions
var _curr_display_width = camera_get_view_width(view_camera[0]);
var _curr_display_height = camera_get_view_height(view_camera[0]);

// Set default draw values
draw_set_color(c_white);
draw_set_alpha(1);

// Checks if audio exists
if (obj_lw_handler.audio_exist)
{
	// Variables for the bar count and width from values present
	var _bar_count = array_length(staged_audio_output);
	var _bar_width = _curr_display_width * (1 / _bar_count);
	
	// Loop through the bars
	for (var _i = 0; _i < _bar_count; _i++)
	{	
		// Sets the bars corner positions
		var _bar_left = _i * _bar_width;
		var _bar_right = _bar_left + _bar_width;
		var _bar_top = _curr_display_height * 0.5 - staged_audio_output[_i] * 0.5;
		var _bar_bottom = _curr_display_height * 0.5 + staged_audio_output[_i] * 0.5;
	
		// Variable sets the max height
		var _bar_max_height = camera_get_view_height(view_camera[0]);
		
		// Sets the colour channels
		var _red_channel = 255 * (staged_audio_output[_i] / _bar_max_height);
		var _green_channel = (255 * (1 - (_i / _bar_count * 0.5))) * (1 - (1 / (255 / _red_channel)));
		var _blue_channel = 255 * 0.1;
		
		// Combines colour channels to new colour
		var _mixed_channels = make_color_rgb(_red_channel,_green_channel,_blue_channel);
		
		// Set draw to new colour
		draw_set_color(_mixed_channels);
		
		// Sets alpha value based on output strength
		draw_set_alpha(0.25 + (staged_audio_output[_i] / _bar_max_height) * 0.75);
		
		// Draw the rectangle based on the audio values
		draw_rectangle(_bar_left, _bar_top, _bar_right, _bar_bottom, false);
	}
}

// Set default draw values
draw_set_color(c_white);
draw_set_alpha(1.0);