// Variables set for battery cell information
// Sets the image index from the charge
var _bat_image_index = ceil(staged_charge / 10);
// Sets the image blend from the charing state
var _bat_image_blend = (staged_state? c_yellow : c_white);

// Adjusts the animation speed to the cell index 
image_speed = 0.1 * _bat_image_index;

// Draws the object
draw_self();

// Draws the cell using the set index and blend from the metric values
draw_sprite_ext(spr_battery_cell, _bat_image_index, x, y, 1.2, 1.2, image_angle + 20, _bat_image_blend, 1);

// Checks if moused over and allowed to show debug info
if (display_info && obj_camera.show_debug)
{
	// Sets text draw values
	draw_set_color(c_black);
	draw_set_alpha(1);
	draw_set_font(fnt_debug);

	draw_set_halign(fa_center);
	draw_set_valign(fa_middle);
	
	// Sets string to values
	var _battery_string = "Battery Name: " + string(staged_name);
	_battery_string += "\nBattery Charging: " + string((staged_state ? "True" : "False"));
	_battery_string += "\nBattery Charge: " + string(staged_charge) + "%";
	
	// Checks the battery is not charging as this value will be arbitrary
	if (!staged_state)
	{
		_battery_string += "\nBattery Time: " + string(staged_time) + " minutes";
	}

	// Draws the text at an adjusted depth before setting it back so it apprears infront of object
	var _old_depth = depth;
	depth = -100;
	draw_text(mouse_x, mouse_y - 100, _battery_string);
	depth = _old_depth;
	
	// Resets draw values
	draw_set_color(c_white);
	draw_set_alpha(1);
	draw_set_halign(fa_left);
	draw_set_valign(fa_top);
}