// Variables
staged_id = -1;
staged_name = "";
staged_cores_l = 0;
staged_cores_p = 0;
staged_usage = -1;
staged_speed_curr = 0;
staged_speed_max = 0;

// Display info state
display_info = false;

// Sets random momentum for intial movement
angle_momentum = random_range(-90, 90);

// Sets default variables
is_held = false;
is_grounded = false;

// Stores previous mouse states
prev_mouse_x = mouse_x;
prev_mouse_y = mouse_y;

// Stores the collision values for audio bar hits
collisions = 0;
new_velo_x = 0;
new_velo_y = 0;
new_angle_velo = 0;

// Function for destroying the object
destroy_cpu = function()
{
	instance_destroy();
}

// Function for making visual particle effect
create_vfx = function()
{
	// Creates intensity variable
	var _intensity = 0;
	
	// Checks the usage value is set
	if (staged_usage != -1)
	{
		// Caluclates intensity from the usage percentage
		_intensity = round(staged_usage * (1 / 20));
	}
	
	// Checks the intensity is not 0
	if (_intensity != 0)
	{
		// Variable of effect set from name
		var _new_ps = asset_get_index("vfx_bubbles_" + string(_intensity));

		// Create new visual effect
		var _new_vfx = instance_create_depth((bbox_left + bbox_right) / 2, bbox_top, depth - 1, obj_particle_handler);
		
		// Setup effect values
		_new_vfx.owner = self;
		_new_vfx.set_vfx(_new_ps);
		_new_vfx.set_offset(0, sprite_width / 4);
		_new_vfx.owner = noone;
	}
}