// Checks for collisions
if (collisions > 0)
{
	// Adds new speed to the current speed scalled by the amount of collisions
	hspeed += new_velo_x / collisions;
	vspeed += new_velo_y / collisions;
	
	// Adds scaled angle momentum
	angle_momentum += new_angle_velo / collisions;

	// Resets collision values
	collisions = 0;
	new_velo_x = 0;
	new_velo_y = 0;
	new_angle_velo = 0;
}

// Checks held state
if (is_held)
{
	// Calculates the change in positions
	var _delta_x = mouse_x - prev_mouse_x;
	var _delta_y = mouse_y - prev_mouse_y;
	
	// Adds the change to the current position
	x += _delta_x;
	y += _delta_y;
	
	// Works out the difference between the mouse and the current object coords 
	var _diff_y = y - mouse_y;
	var _diff_x = x - mouse_x;

	// Fall
	if (_diff_y < 0)
	{
		// Checks for momentum
		if (abs(angle_momentum) > 1)
		{
			// Clamps
			angle_momentum += clamp(angle_momentum * 1.2, -7.5, 7.5);
		}
		else
		{
			// Swing
			angle_momentum = clamp(_diff_x * -1, -1.1, 1.1);
		}
	}
	else
	{
		// Swing
		angle_momentum -= clamp(_delta_x * min(1, abs(_delta_y) * 0.1), -15, 15) * 0.5;
	}
	
	// Horizonal difference
	if (abs(_diff_x) > 30)
	{
		// Fall
		angle_momentum -= _diff_x * 0.2 * min(1, (1 - 30 / abs(_diff_x)));
	}
}