// Checks for handler
if (!instance_exists(obj_lw_handler))
{
	// Creates the LW handler
	var _lw_handler = instance_create_depth(0, 0, 0, obj_lw_handler);
}

// Function for creating a new object
create_cpu = function(_id)
{
	// Wallpaper position data
	var _center_x = obj_camera.wallpaper_width * 0.5;
	var _center_y = obj_camera.wallpaper_height * 0.5;

	var _curr_display_width = camera_get_view_width(view_camera[0]);
	var _curr_display_height = camera_get_view_height(view_camera[0]);

	var _origin_x = _center_x - (_curr_display_width * 0.5);
	var _origin_y = _center_y - (_curr_display_height * 0.5);
	
	// Creates new object
	var _new_cpu = instance_create_depth(_origin_x + (_curr_display_width * 0.4), _origin_y - 200 , depth + 2, obj_cpu);
	
	// Sets new object variables from id parameter
	_new_cpu.staged_id = _id;
	_new_cpu.staged_name = obj_lw_handler.cpu_name[_id];
	_new_cpu.staged_cores_l = obj_lw_handler.cpu_logical_cores[_id];
	_new_cpu.staged_cores_p = obj_lw_handler.cpu_physical_cores[_id];
	_new_cpu.staged_usage = obj_lw_handler.cpu_usage[_id];
	_new_cpu.staged_speed_curr = obj_lw_handler.cpu_curr_speed[_id];
	_new_cpu.staged_speed_max = obj_lw_handler.cpu_max_speed[_id];
}