// Variables
staged_id = -1;
staged_name = "";
staged_usage = 0;
staged_clock_speed = 0;
staged_fan_pct = -1;
staged_fan_rpm = -1;
staged_power = 0;
staged_temp = 0;
staged_mem_used = 0;
staged_mem_avail = 0;
staged_mem_total = 0;

// Display info state
display_info = false;

// Sets random momentum for intial movement
angle_momentum = random_range(-90, 90);

// Sets default variables
is_held = false;
is_grounded = false;

// Stores previous mouse states
prev_mouse_x = mouse_x;
prev_mouse_y = mouse_y;

// Stores the collision values for audio bar hits
collisions = 0;
new_velo_x = 0;
new_velo_y = 0;
new_angle_velo = 0;

// Function for destroying the object
destroy_gpu = function()
{
	instance_destroy();
}

// Function for making visual particle effect
create_vfx = function()
{
	// Creates intensity variable from the temperature data
	var _intensity = clamp(round(staged_temp * (1 / 16)), 0, 5);

	// Checks the intensity is not 0
	if (_intensity != 0)
	{
		// Variable of effect set from name
		var _new_ps = asset_get_index("vfx_steam_" + string(_intensity));

		// Create new visual effect
		var _new_vfx = instance_create_depth((bbox_left + bbox_right) / 2, bbox_top, depth - 1, obj_particle_handler);
		
		// Setup effect values
		_new_vfx.owner = self;
		_new_vfx.set_vfx(_new_ps);
		_new_vfx.set_angle(true, 0);
		_new_vfx.set_offset(0, sprite_height * 0.5);
	}
}