// Checks for handler
if (!instance_exists(obj_lw_handler))
{
	// Creates the LW handler
	var _lw_handler = instance_create_depth(0, 0, 0, obj_lw_handler);
}

// Function for creating a new object
create_gpu = function(_id)
{
	// Wallpaper position data
	var _center_x = obj_camera.wallpaper_width * 0.5;
	var _center_y = obj_camera.wallpaper_height * 0.5;

	var _curr_display_width = camera_get_view_width(view_camera[0]);
	var _curr_display_height = camera_get_view_height(view_camera[0]);

	var _origin_x = _center_x - (_curr_display_width * 0.5);
	var _origin_y = _center_y - (_curr_display_height * 0.5);
	
	// Creates new object
	var _new_gpu = instance_create_depth(_origin_x + (_curr_display_width * 0.6), _origin_y - 200 , depth + 3, obj_gpu);
	
	// Sets new object variables from id parameter
	_new_gpu.staged_id = _id;
	_new_gpu.staged_name = obj_lw_handler.gpu_name[_id];
	_new_gpu.staged_uasge = obj_lw_handler.gpu_usage[_id];
	_new_gpu.staged_clock_speed = obj_lw_handler.gpu_clock_speed[_id];
	_new_gpu.staged_fan_pct = obj_lw_handler.gpu_fan_speed_pct[_id];
	_new_gpu.staged_fan_rpm = obj_lw_handler.gpu_fan_speed_rpm[_id];
	_new_gpu.staged_power = obj_lw_handler.gpu_power[_id];
	_new_gpu.staged_temp = obj_lw_handler.gpu_temp[_id];
	_new_gpu.staged_mem_used = obj_lw_handler.gpu_memory_used[_id];
	_new_gpu.staged_mem_avail = obj_lw_handler.gpu_memory_available[_id];
	_new_gpu.staged_mem_total = obj_lw_handler.gpu_memory_total[_id];
}