// Variable for storing object count
var _gpu_count = instance_number(obj_gpu);

// Checks for if data can exist
if (obj_lw_handler.gpu_exist)
{
	// Loops while more data exists as objects
	while (obj_lw_handler.gpu_count > _gpu_count)
	{
		// Loops through data count
		for (var _i = 0; _i < obj_lw_handler.gpu_count; _i++)
		{
			// Variable for is found
			var _is_found = false;
			{
				// Checks all objects
				with (obj_gpu)
				{
					// Checks if name is the same
					if (staged_name == obj_lw_handler.gpu_name[_i])
					{
						// Sets found state
						_is_found = true;
						// Breaks loop
						break;
					}
				}
				
				// Checks if matching object hasnt been found
				if (!_is_found)
				{
					// Creates object with ID
					create_gpu(_i);
					// Increases object count 
					_gpu_count++;
					// Breaks loop
					break;
				}
			}
		}
	}

	// Loops while less data exists than objects
	while (obj_lw_handler.gpu_count < _gpu_count)
	{
		// Checks objects
		with (obj_gpu)
		{
			// Sets found state to false
			var _is_found = false;
			
			// Loops through data values
			for (var _i = 0; _i < obj_lw_handler.gpu_count; _i++)
			{
				// Checks for matching names
				if (staged_name == obj_lw_handler.gpu_name[_i])
				{
					// Sets found to true
					_is_found = true;
					// Stops breaks loop
					break;
				}
			}
			
			// Checks if hasnt been found
			if (!_is_found)
			{
				// Destroys the object
				destroy_gpu();
				// Decreases the object count
				_gpu_count--;
				// Breaks loop
				break;
			}
		}
	}
}
else
{
	// Loops through all objects
	with (obj_gpu)
	{
		// Calls destroy function
		destroy_gpu();
	}
}