// Gets GUI dimensions
var _curr_display_width = room_width;
var _curr_display_height = room_height;

// Sets font draw options
draw_set_color(c_black);
draw_set_alpha(1);
draw_set_font(fnt_debug);
draw_set_halign(fa_left);
draw_set_valign(fa_top);

// Draws fps info and metric update info
var _fps = 1 / (delta_time * 0.000001);
draw_text(_curr_display_width * 0.05, _curr_display_height * 0.05, "FPS: " + string(_fps) + "\nAverage UPS: " + string(1 / avg_interval));

// Set text alignement
draw_set_halign(fa_center);
draw_set_valign(fa_middle);

// Main metric info string
var _metric_string = "Metric Info:";
_metric_string += "\nCPU Devices Detected: " + string(cpu_count);
_metric_string += "\nGPU Devices Detected: " + string(gpu_count);
_metric_string += "\nBattery Devices Detected: " + string(battery_count);
_metric_string += "\nRAM Devices Detected: " + string(ram_count);
_metric_string += "\nDisk Devices Detected: " + string(ram_count);
_metric_string += "\nNetwork Devices Detected: " + string(network_count);
_metric_string += "\nAudio Detected: " + string((audio_exist ? "True" : "False"));
_metric_string += "\nMouse Location: (" + string(mouse_x) + " ," + string(mouse_y) + ")";
_metric_string += "\nNext Update in: " + string(update_cooldown);

// Metric timings
_metric_string += "\n\nMetric Timing:";
_metric_string += "\nUpdate Count: " + string(update_count);
_metric_string += "\nCurrent interval: " + string(curr_interval);

// Calculated average
var _curr_avg = ((avg_interval * update_count) + curr_interval) * (1 / (update_count + 1));
_metric_string += "\nAverage interval: " + string(_curr_avg);

// Draw string
draw_text(_curr_display_width * 0.5, _curr_display_height * 0.5, _metric_string);

if (cpu_exist)
{
	var _cpu_string = "CPU Output:";
	
	for (var _i = 0; _i < cpu_count; _i++)
	{
		// Check for variable as might not always exist
		if (cpu_name[_i] != -1)
		{
			_cpu_string += "\nCPU Name: " + string(cpu_name[_i]);
		}
		
		// Check for variable as might not always exist
		if (cpu_logical_cores[_i] != -1)
		{
			_cpu_string += "\nCPU Logical Cores: " + string(cpu_logical_cores[_i]);
		}
		
		// Check for variable as might not always exist
		if (cpu_physical_cores[_i] != -1)
		{
			_cpu_string += "\nCPU Phycial Cores: " + string(cpu_physical_cores[_i]);
		}
		
		// Check for variable as might not always exist
		if (cpu_usage[_i] != -1)
		{
			_cpu_string += "\nCPU Usage: " + string(cpu_usage[_i]) + "%";
		}
		
		// Check for variable as might not always exist
		if (cpu_curr_speed[_i] != -1)
		{
			_cpu_string += "\nCPU Current Speed: " + string(cpu_curr_speed[_i]) + " MHz";
		}
		
		// Check for variable as might not always exist
		if (cpu_max_speed[_i] != -1)
		{
			_cpu_string += "\nCPU Maximum Speed: " + string(cpu_max_speed[_i]) + " MHz";
		}
		
		// Check for variable as might not always exist
		if (cpu_power[_i] != -1)
		{
			_cpu_string += "\nCPU Voltage: " + string(cpu_power[_i]) + " V";
		}
	}
	
	draw_text(_curr_display_width * 0.25, _curr_display_height * 0.25, _cpu_string);
}

if (gpu_exist)
{
	var _gpu_string = "GPU Output:";
	
	for (var _i = 0; _i < gpu_count; _i++)
	{
		// Check for variable as might not always exist
		if (gpu_name[_i] != "")
		{
			_gpu_string += "\nGPU Name: " + string(gpu_name[_i]);
		}
		
		// Check for variable as might not always exist
		if (gpu_usage[_i] != -1)
		{
			_gpu_string += "\nGPU Usage: " + string(gpu_usage[_i]) + "%";
		}
		
		// Check for variable as might not always exist
		if (gpu_clock_speed[_i] != -1)
		{
			_gpu_string += "\nGPU Clock Speed: " + string(gpu_clock_speed[_i]) + " MHz";
		}
		
		// Check for variable as might not always exist
		if (gpu_fan_speed_pct[_i] != -1)
		{
			_gpu_string += "\nGPU Fan Speed: " + string(gpu_fan_speed_pct[_i]) + "%";
		}
		
		// Check for variable as might not always exist
		if (gpu_fan_speed_rpm[_i] != -1)
		{
			_gpu_string += "\nGPU Fan Speed: " + string(gpu_fan_speed_rpm[_i]) + " rmp";
		}
		
		// Check for variable as might not always exist
		if (gpu_power[_i] != -1)
		{
			_gpu_string += "\nGPU Power: " + string(gpu_power[_i]) + " Watt";
		}
		
		// Check for variable as might not always exist
		if (gpu_temp[_i] != -1)
		{
			_gpu_string += "\nGPU Temp: " + string(gpu_temp[_i]) + " °C";
		}
		
		// Check for variable as might not always exist
		if (gpu_memory_used[_i] != -1)
		{
			_gpu_string += "\nGPU Memory Used: " + string(gpu_memory_used[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (gpu_memory_available[_i] != -1)
		{
			_gpu_string += "\nGPU Memory Available: " + string(gpu_memory_available[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (gpu_memory_total[_i] != -1)
		{
			_gpu_string += "\nGPU Memory Total: " + string(gpu_memory_total[_i]) + " bytes";
		}
	}
	
	draw_text(_curr_display_width * 0.25, _curr_display_height * 0.5, _gpu_string);
}

if (battery_exist)
{
	var _battery_string = "Battery Output:";
	
	for (var _i = 0; _i < battery_count; _i++)
	{
		// Check for variable as might not always exist
		if (battery_name[_i] != "")
		{
			_battery_string += "\nBattery Name: " + string(battery_name[_i]);
		}
		
		// Check for variable as might not always exist
		if (battery_is_charging[_i] != -1)
		{
			_battery_string += "\nBattery Charging: " + string((battery_is_charging[_i] ? "True" : "False"));
		}
		
		// Check for variable as might not always exist
		if (battery_charge[_i] != -1)
		{
			_battery_string += "\nBattery Charge: " + string(battery_charge[_i]) + "%";
		}
		
		// Check for variable as might not always exist
		if (battery_time[_i] != -1 || battery_is_charging == false)
		{
			_battery_string += "\nBattery Time: " + string(battery_time[_i]) + " minutes";
		}
	}
	
	draw_text(_curr_display_width * 0.25, _curr_display_height * 0.75, _battery_string);
}

if (ram_exist)
{
	var _ram_string = "RAM Output:";
	
	for (var _i = 0; _i < ram_count; _i++)
	{
		// Check for variable as might not always exist
		if (ram_name[_i] != "")
		{
			_ram_string += "\nRAM Name: " + string(ram_name[_i]);
		}
		
		// Check for variable as might not always exist
		if (ram_used[_i] != -1)
		{
			_ram_string += "\nRAM Used: " + string(ram_used[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (ram_available[_i] != -1)
		{
			_ram_string += "\nRAM Available: " + string(ram_available[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (ram_total[_i] != -1)
		{
			_ram_string += "\nRAM Total: " + string(ram_total[_i]) + " bytes";
		}
	}
	
	draw_text(_curr_display_width * 0.75, _curr_display_height * 0.25, _ram_string);
}

if (disk_exist)
{
	var _disk_string = "Disk Output:";
	
	for (var _i = 0; _i < disk_count; _i++)
	{
		// Check for variable as might not always exist
		if (disk_name[_i] != "")
		{
			_disk_string += "\nDisk Name: " + string(disk_name[_i]);
		}
		
		// Check for variable as might not always exist
		if (disk_used[_i] != -1)
		{
			_disk_string += "\nDisk Used: " + string(disk_used[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (disk_available[_i] != -1)
		{
			_disk_string += "\nDisk Available: " + string(disk_available[_i]) + " bytes";
		}
		
		// Check for variable as might not always exist
		if (disk_total[_i] != -1)
		{
			_disk_string += "\nDisk Total: " + string(disk_total[_i]) + " bytes";
		}
	}
	
	draw_text(_curr_display_width * 0.75, _curr_display_height * 0.5, _disk_string);
}

if (network_exist)
{
	var _network_string = "Network Output:";
	
	for (var _i = 0; _i < network_count; _i++)
	{
		// Check for variable as might not always exist
		if (network_bandwidth[_i] != -1)
		{
			_network_string += "\nNetwork Bandwith: " + string(network_bandwidth[_i]) + " bps";
		}
		
		// Check for variable as might not always exist
		if (network_send[_i] != -1)
		{
			_network_string += "\nNetwork Send: " + string(network_send[_i]) + " bps";
		}
		
		// Check for variable as might not always exist
		if (network_receive[_i] != -1)
		{
			_network_string += "\nNetwork Receive: " + string(network_receive[_i]) + " bps";
		}
	}
	
	draw_text(_curr_display_width * 0.75, _curr_display_height * 0.75, _network_string);
}

if (audio_exist)
{
	var _audio_string = "Audio Output:";
	
	var _ao_length = array_length(audio_output);
	_audio_string += "\n" + string(_ao_length) + " values";
	
	draw_text(_curr_display_width * 0.5, _curr_display_height * 0.75, _audio_string);
}

draw_set_color(c_white);
draw_set_alpha(1);
draw_set_halign(fa_left);
draw_set_valign(fa_top);