// Empty variable for setting the particle system to
particle_sys = -1;

// Variable for setting the parent object to set to noone to start
owner = noone;

// Variables used for angle adjust
is_angle_inhert = false;
angle_adjust = 0;

// Variables used for if the particle system is to be set to an offset and what the offset should be
is_offset = false;
x_offset = 0;
y_offset = 0;

// Variable used for stream effects
is_stream = false;
stream_life = 0;
stream_fade_rate = 0;

// Alpha variables used for lerping alpha values
target_alpha = 0;
current_alpha = 0;

// Function used for setting particle systems angle
set_angle = function(_new_is_angle_inhert, _new_angle_adjust)
{
	// Sets default angle
	var _new_angle = 0;
	
	// Check for if angle should inhert from owner
	if (_new_is_angle_inhert)
	{
		// Sets inhert values
		is_angle_inhert = true;
		_new_angle = owner.image_angle;
	}
	
	// Sets adjustment for angles to be used during updates
	angle_adjust = _new_angle_adjust;
	_new_angle += angle_adjust;
	
	// Updates particle systems angle
	part_system_angle(particle_sys, _new_angle);
}

// Function used for setting particle systems offset position
set_offset = function(_x_offset, _y_offset)
{
	// Variables set to new variables
	is_offset = true;
	x_offset = _x_offset;
	y_offset = _y_offset;
	
	var _new_angle = angle_adjust;
	
	if (is_angle_inhert)
	{
		// Stores the owners angle as a real variable
		_new_angle += owner.image_angle;
		// Applies angle to particle system
		part_system_angle(particle_sys, _new_angle);
	}
	
	// Converts angle to radians
	var _theta = degtorad(_new_angle);
	
	// Calculates the adjusted repositioned angles from the set offsets and angle
	var _adjust_x = (x_offset * cos(_theta)) - (y_offset * sin(_theta));
	var _adjust_y = (y_offset * cos(_theta)) + (x_offset * sin(_theta));
	
	// Updates the position to the adjusted owner positions
	x = owner.x + _adjust_x;
	y = owner.y - _adjust_y;
	
	// Updates particle system position
	part_system_position(particle_sys, x, y);
}

// Function for setting stream particle effects
set_stream = function(_stream_life, _stream_fade_rate)
{
	// Variables set to new variables
	is_stream = true;
	stream_life = _stream_life;
	stream_fade_rate = _stream_fade_rate;
}

// Function used for setting particle system
set_vfx = function(_vfx)
{
	// Creates smoke particle system
	particle_sys = part_system_create_layer("Effects", false, _vfx);
	// Updates particle system position
	part_system_position(particle_sys, x, y);
}