// Checks if owner has been set
if (owner != noone)
{	
	// New angle variable
	var _new_angle = angle_adjust;
	
	if (is_angle_inhert)
	{
		// Stores the owners angle as a real variable
		_new_angle += owner.image_angle;
		// Applies angle to particle system
		part_system_angle(particle_sys, _new_angle);
	}
	
	// Checks if postion should be at an offset
	if (is_offset)
	{ 
		// Converts angle to radians
		var _theta = degtorad(_new_angle);
	
		// Calculates the adjusted repositioned angles from the set offsets and angle
		var _adjust_x = (x_offset * cos(_theta)) - (y_offset * sin(_theta));
		var _adjust_y = (y_offset * cos(_theta)) + (x_offset * sin(_theta));
	
		// Updates the position to the adjusted owner positions
		x = owner.x + _adjust_x;
		y = owner.y - _adjust_y;
	}
	else
	{
		// Updates the position to the owner positions
		x = owner.x;
		y = owner.y;
	}
	
	// Updats the particle system position to the object position
	part_system_position(particle_sys, x, y);
}

// Checks if stream particle system
if (is_stream)
{
	// Decrease life over time
	stream_life -= delta_time * 0.000001;
	
	// Checks if stream should die
	if (stream_life <= 0)
	{
		// Lerps alpha to 0
		current_alpha = lerp(current_alpha, 0, stream_fade_rate);
			
		// Sets alpha
		part_system_color(particle_sys, c_white, current_alpha);
			
		// Checks if particles are invisible
		if (current_alpha <= 0)
		{
			// Destroys the object
			instance_destroy();
		}
	}
}
// Checks if the burst particle system has finished
else if (part_particles_count(particle_sys) == 0)
{
	// Destroys the object
	instance_destroy();
}
